// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _Vrtavr_veri_H_
#define _Vrtavr_veri_H_

#include "verilated.h"
class Vrtavr_veri__Syms;

//----------

VL_MODULE(Vrtavr_veri) {
  public:
    // CELLS
    // Public to allow access to /*verilator_public*/ items;
    // otherwise the application code can consider these internals.
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(CLK_IN,0,0);
    VL_IN8(SPI_MOSI,0,0);
    VL_OUT8(SPI_MISO,0,0);
    VL_IN8(SPI_SS,0,0);
    VL_IN8(SPI_SCLK,0,0);
    VL_IN8(ISP_MOSI,0,0);
    VL_OUT8(ISP_MISO,0,0);
    VL_IN8(ISP_SS,0,0);
    VL_IN8(ISP_SCLK,0,0);
    //char	__VpadToAlign9[3];
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    VL_SIG8(v__DOT__CLK,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r_cs,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r_sck,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r_spi_in,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r_count,3,0);
    VL_SIG8(v__DOT__ISP__DOT__r_spi,7,0);
    VL_SIG8(v__DOT__ISP__DOT__r_data,7,0);
    VL_SIG8(v__DOT__ISP__DOT__r_store,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r2_store,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r_load,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r_sstpr_hi,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r_sstpr_lo,0,0);
    VL_SIG8(v__DOT__ISP__DOT__r_pr_inc,0,0);
    VL_SIG8(v__DOT__ISP__DOT__f7_sld_sst,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__r_clk,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR_WE,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR_DI,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__FLAGS_OUT,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR_RST_USART_TX,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__RAM_DOB,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__ROM_WEB,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__ROM_DOB,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0_VALID,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__oe_ram,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__wr_ior,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__rd_ior,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__C_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__Z_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__N_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__V_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__H_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__T_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__I_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__C_in_l,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__v_sbrx_bit,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__v_bld_out,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__v_sbri_bit,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__r_sbri_bit,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__v_ior_dob2,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__load_data,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__store_data,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__r_int_vec,4,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR_SPI_INT,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0_WB_INST,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0_IDX_INST,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__INT_ACK,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__r_addra,3,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__r_addrb,3,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__s2_DOBL,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__s2_DOBH,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__c,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__ci,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__WB,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__r_wb_addr,3,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__DOA,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__DOB,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__DOA2H,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__s1_DOAL,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__s1_DOBL,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__r_forward_to_bl,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__r_do,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__WE_ucsrb,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__WE_ucsra,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__OE_udr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__WE_spdr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__WE_spcr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__PS0_INT0,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__PS0_TIM0_OVF,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__PS0_TIM0_COMPA,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__PS0_TIM0_COMPB,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__r_sreg,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__r_sph,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__r_spl,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__nvm_wp,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__WE_tifr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_ovf_prev,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_compa_prev,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_compb_prev,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_ovf,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_ovf_ie,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_compa,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_compa_ie,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_compb,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_compb_ie,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__gi_int0_prev,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__gi_int0,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__gi_int0_ie,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__mcucr_isc,1,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__WE_tccr0b,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_tcnt0,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_ocr0b,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_ocr0a,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_tim0_compa,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_tim0_compb,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_tim0_ovf,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__CS0,2,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__WGM0,2,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__COM0A,1,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__COM0B,1,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__tsm,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__psr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__v_psr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__t0_prev,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__t0_clk,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_ps,6,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_count_en,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_count,3,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_spsr_lck,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_spdr,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__c,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_spif,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__SPIE,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__SPE,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__SPR,2,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__i_sck,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_sck,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__do_count,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__cond_spif_1,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_ps,3,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_count,4,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_count_max_x,1,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_count_en,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_data_load,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_txd,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_ps,3,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_count,4,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_count_en,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_data_rdy,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_udr_rdy,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_parity,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_c,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_udr_tx,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_udr_rx,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__RXC,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__TXC,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__FE,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__DOR,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__UPE,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__RXCIE,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__TXCIE,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__UDRIE,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_en,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_en,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__RXB8,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__TXB8,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_tclk,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__do_txcount,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_rclk,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__do_rxcount,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_port_c__DOT__r_pin,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_port_c__DOT__r_ddr,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__IOR__DOT__i_port_c__DOT__r_port,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__ROM__DOT__r_doh,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__ROM__DOT__r_tmp,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__s1_predec,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__s1_postinc,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__s1_addr_ah,3,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__s1_addr_bh,3,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__pd0_ext,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__s1_sbix,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__v_predec,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__v_postinc,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__v_xreg,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__v_yreg,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__v_zreg,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__v_icall,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__v_ldst,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S0__DOT__s_idx_off,4,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__n_reset,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s1_invalid,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__r_invalid,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__i1_int,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__i2_int,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__i2_call,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__i2_ret,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__i3_ret,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__i2_reti,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__i3_reti,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_load,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_load_wr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_store,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_alu_wr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_alu_wrf,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_alu_imm,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_alu_sel,2,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_op1,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_op1_sel,2,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_bst,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_bld,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_xbi,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_alu_es1,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_alu_es0,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_cmd_alu_com,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_xbi_bit_out,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_ea_push,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_ea_pop,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_push_sel,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__r_sleep,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_sbix,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_sbix_sel,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_sbix_bit,2,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_sbrx,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_delayed_skip,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_skip3,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__r_imm,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__r_tmp,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_bset_bclr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_ea_abs,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s2_skip,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_alu_sub,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_alu_add,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_alu_and,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_alu_or,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_alu_wr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_alu_com,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_alu_dec,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_alu_inc,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_alu_es0,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_op1,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_alu_es1,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_ldst_all,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_xbi,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_cmd_load_wr,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_ij,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_ic,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_ret,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_push_pop,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_calls,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_ea_pop,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_ea_push,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_br,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_skip,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_mcu,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__f_sleep,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s0_inv_conflict,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s0_inv_jump,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__s0_inv_skip,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__S1__DOT__v_int,0,0);
    VL_SIG8(v__DOT__RTAVR__DOT__ALU__DOT__AX,7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__ALU__DOT__BX,7,0);
    //char	__VpadToAlign257[1];
    VL_SIG16(v__DOT__ISP__DOT__r_pr,15,0);
    VL_SIG16(v__DOT__RTAVR__DOT__GPR_JA,11,0);
    VL_SIG16(v__DOT__RTAVR__DOT__GPR_INDEX,15,0);
    VL_SIG16(v__DOT__RTAVR__DOT__SP_OUT,15,0);
    VL_SIG16(v__DOT__RTAVR__DOT__RAM_ADDRB,12,0);
    VL_SIG16(v__DOT__RTAVR__DOT__ROM_DOA,15,0);
    VL_SIG16(v__DOT__RTAVR__DOT__EA,15,0);
    VL_SIG16(v__DOT__RTAVR__DOT__OP1_OUT,8,0);
    VL_SIG16(v__DOT__RTAVR__DOT__GPR__DOT__DOA2LO,8,0);
    VL_SIG16(v__DOT__RTAVR__DOT__GPR__DOT__WB_DATA,8,0);
    VL_SIG16(v__DOT__RTAVR__DOT__IOR__DOT__PS0_SP_OUT,15,0);
    VL_SIG16(v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_prescaler,9,0);
    VL_SIG16(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_ps,11,0);
    VL_SIG16(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_data,9,0);
    VL_SIG16(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_data,10,0);
    VL_SIG16(v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__UBRR,11,0);
    VL_SIG16(v__DOT__RTAVR__DOT__RAM__DOT__r_addrb,12,0);
    VL_SIG16(v__DOT__RTAVR__DOT__ROM__DOT__r_addra,11,0);
    VL_SIG16(v__DOT__RTAVR__DOT__ROM__DOT__r_addrb,11,0);
    VL_SIG16(v__DOT__RTAVR__DOT__S0__DOT__s1_inst,15,0);
    VL_SIG16(v__DOT__RTAVR__DOT__S1__DOT__s2_ea,15,0);
    VL_SIG16(v__DOT__RTAVR__DOT__S1__DOT__r_pc,11,0);
    VL_SIG16(v__DOT__RTAVR__DOT__ALU__DOT__ALU_OUT,8,0);
    VL_SIG(v__DOT__PORT,23,0);
    VL_SIG(v__DOT__PIN,23,0);
    VL_SIG(v__DOT__RTAVR__DOT__IOR__DOT__PORT_IN,23,0);
    //char	__VpadToAlign316[4];
    VL_SIG8(v__DOT__RTAVR__DOT__GPR__DOT__gpr[16],7,0);
    VL_SIG8(v__DOT__RTAVR__DOT__RAM__DOT__mem[2048],7,0);
    VL_SIG16(v__DOT__RTAVR__DOT__ROM__DOT__rom[2048],15,0);
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    VL_SIG8(v__DOT__RTAVR__DOT____Vcellinp__ALU__ES,1,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_cs,0,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_sck,0,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_load,0,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_count,3,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_spi,7,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_spi_in,0,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_store,0,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_sstpr_hi,0,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_sstpr_lo,0,0);
    VL_SIG8(__Vdly__v__DOT__ISP__DOT__r_pr_inc,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__r_clk,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_ovf_prev,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_compa_prev,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__t0_compb_prev,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__mcucr_isc,1,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__gi_int0_prev,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_ocr0b,7,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_ocr0a,7,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__CS0,2,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__WGM0,2,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__r_tcnt0,7,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__IOR_PS0__DOT__i_timer0__DOT__t0_prev,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_ps,6,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_spdr,7,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__c,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_spif,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_spsr_lck,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_sck,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_count_en,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_spi__DOT__r_count,3,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_tclk,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_rclk,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_ps,3,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_data_load,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_count,4,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_count_max_x,1,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_count_en,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_ps,3,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_count,4,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_count_en,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_data_rdy,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_udr_rdy,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_udr_tx,7,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_en,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_en,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_parity,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_c,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_port_c__DOT__r_ddr,7,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_port_c__DOT__r_port,7,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__n_reset,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__i1_int,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__r_tmp,7,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__i2_call,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__i2_ret,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__i3_ret,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__i2_reti,0,0);
    VL_SIG8(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__r_sleep,0,0);
    VL_SIG8(__VinpClk__TOP__v__DOT__CLK,0,0);
    VL_SIG8(__Vclklast__TOP____VinpClk__TOP__v__DOT__CLK,0,0);
    VL_SIG8(__Vclklast__TOP__CLK_IN,0,0);
    VL_SIG8(__Vchglast__TOP__v__DOT__CLK,0,0);
    VL_SIG16(__Vdly__v__DOT__ISP__DOT__r_pr,15,0);
    VL_SIG16(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__r_ps,11,0);
    VL_SIG16(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__tx_data,9,0);
    VL_SIG16(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__rx_data,10,0);
    VL_SIG16(__Vdly__v__DOT__RTAVR__DOT__IOR__DOT__i_usart__DOT__UBRR,11,0);
    VL_SIG16(__Vdly__v__DOT__RTAVR__DOT__S0__DOT__s1_inst,15,0);
    VL_SIG16(__Vdly__v__DOT__RTAVR__DOT__S1__DOT__r_pc,11,0);
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    //char	__VpadToAlign6564[4];
    Vrtavr_veri__Syms*	__VlSymsp;		// Symbol table
    
    // PARAMETERS
    // Parameters marked /*verilator public*/ for use by application code
    
    // CONSTRUCTORS
  private:
    Vrtavr_veri& operator= (const Vrtavr_veri&);	///< Copying not allowed
    Vrtavr_veri(const Vrtavr_veri&);	///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible WRT DPI scope names.
    Vrtavr_veri(const char* name="TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~Vrtavr_veri();
    
    // USER METHODS
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(Vrtavr_veri__Syms* __restrict vlSymsp);
  public:
    void __Vconfigure(Vrtavr_veri__Syms* symsp, bool first);
  private:
    static IData	_change_request(Vrtavr_veri__Syms* __restrict vlSymsp);
  public:
    static void	_combo__TOP__10(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_combo__TOP__17(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_combo__TOP__21(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_combo__TOP__26(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_eval(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_eval_initial(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_eval_settle(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_initial__TOP(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_multiclk__TOP__16(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_multiclk__TOP__20(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_multiclk__TOP__25(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_multiclk__TOP__9(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__11(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__12(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__14(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__15(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__18(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__2(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__22(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__23(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__3(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__4(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__5(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__6(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__8(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_settle__TOP__13(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_settle__TOP__19(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_settle__TOP__24(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_settle__TOP__27(Vrtavr_veri__Syms* __restrict vlSymsp);
    static void	_settle__TOP__7(Vrtavr_veri__Syms* __restrict vlSymsp);
} VL_ATTR_ALIGNED(64);

#endif  /*guard*/
